%ifdef TEST_H_
    global _my_memcpy
    _my_memcpy: ; void *memcpy(void *dest, const void *src, size_t n)
%else
    global memcpy
    memcpy:
%endif
    xor    rax, rax
    xor rcx, rcx

_my_memcpy_loop:
    cmp   rcx, rdx
    jge   _my_memcpy_end
    inc  rcx
    mov al, [rsi]
    mov [rdi], al
    inc  rdi
    inc  rsi
    jmp  _my_memcpy_loop

_my_memcpy_end:
    sub rdi, rcx
    mov rax, rdi
    ret
