%ifdef TEST_H_
     global _my_strcasecmp; int strcmp(const char *s1, const char *s2)
     _my_strcasecmp:
%else
    global strcasecmp
    strcasecmp:
%endif
    xor eax, eax ; clear the value of eax to zero
    xor ebx, ebx ; clear the value of ebx to zero

_my_strcasecmp_loop:
    mov al, byte [rdi] ; load the value at the memory location pointed to by `rdi` into `al`
    mov bl, byte [rsi] ; load the value at the memory location pointed to by `rsi` into `bl`
    cmp al, 'A' ; if the value in `al` is greater than or equal to 97, jump to `_my_strcasecmp_uppercase`
    jl _notupper_a ; if the value in `al` is less than 97, jump to `_my_strcasecmp_uppercase`
    cmp al, 'Z' ; if the value in `al` is less than or equal to 122, jump to `_my_strcasecmp_uppercase`
    jg _notupper_a ; if the value in `al` is greater than 122, jump to `_my_strcasecmp_uppercase`
    add al, 32 ; subtract 32 from the value in `al` and store the result in `al`
_notupper_a:
    cmp bl, 'A' ; if the value in `bl` is greater than or equal to 97, jump to `_my_strcasecmp_uppercase`
    jl _notupper_b ; if the value in `bl` is less than 97, jump to `_my_strcasecmp_uppercase`
    cmp bl, 'Z' ; if the value in `bl` is less than or equal to 122, jump to `_my_strcasecmp_uppercase`
    jg _notupper_b ; if the value in `bl` is greater than 122, jump to `_my_strcasecmp_uppercase`
    add bl, 32 ; subtract 32 from the value in `bl` and store the result in `bl`
_notupper_b:
    inc rdi ; increment the value of `rdi` by 1 to point to the next character in string 1
    inc rsi ; increment the value of `rsi` by 1 to point to the next character in string 2
    cmp al, bl ; compare the value in `al` with the value in `bl`
    jne _my_strcmp_not_equal ; if the value in `al` is not equal to bl, jump to `_my_strcmp_not_equal`
    cmp al, 0 ; compare the value in `al` with 0
    je _my_strcasecmp_equal ; if the value in `al` is equal to 0, jump to `_my_strcmp_equal`
    jmp _my_strcasecmp_loop ; if the values are equal, jump to `_my_strcmp_loop`

_my_strcasecmp_equal:
    mov eax, 0 ; set the value in `eax` to 0
    ret ; return from the function

_my_strcmp_not_equal:
    sub eax, ebx ; subtract the value in `ah` from the value in `al` and store the result in `eax`
    ret ; return from the function

