%ifdef TEST_H_
    global _my_strrchr
    _my_strrchr: ; int strcmp(const char *s1, const char *s2)
%else
    global strrchr
    strrchr: ; int strcmp(const char *s1, const char *s2)
%endif
    xor eax, eax ; clear the value of eax to zero
    xor ebx, ebx ; clear the value of ebx to zero
    mov rcx, rdi ; copy the value of rdi into rcx
init_loop:
    cmp byte [rcx], 0 ; compare the value in  [rdi] with 0
    je _my_strrchr_loop ; if the value in `al` is equal to 0, jump to `_my_strcmp_equal`
    inc rcx ; increment the value of rcx by 1 to point to the next character in string 1
    jmp init_loop ; jump to the start of the loop

_my_strrchr_loop:
    dec rcx ; decrement the value of rcx by 1 to point to the next character in string 1
    mov al, byte [rcx] ; load the value at the memory location pointed to by `rdi` into `al`
    cmp al, 0 ; compare the value in `al` with 0
    je _my_strrchr_not_equal ; if the value in `al` is equal to 0, jump to `_my_strcmp_equal`
    cmp al, sil ; compare the value in `al` with the value in `sil`
    jne  _my_strrchr_loop; if the value in `al` is equal to 'sil' jump to `_my_strcmp_equal`
    mov rax, rcx
    ret ; return from the function

_my_strrchr_not_equal:
    xor rax, rax ; clear the value of `rax` to zero
    ret ; return from the function

