%ifdef TEST_H_
     global _my_memmove
     _my_memmove: ; void *memmove(void *dest, const void *src, size_t n)
%else
    global memmove
    memmove:
%endif
    xor rax, rax
    xor rcx, rcx
    cmp rdx, 0
    je _my_memcpy_null;
    cmp rdi, rsi
    jg _my_memmove_init
    jmp _my_memcpy
_my_memmove_init:
    add rdi, rdx
    add rsi, rdx
_my_memmove_loop:
    dec rdi
    dec rsi
    mov al, [rsi]
    mov [rdi], al
    inc rcx
    cmp rcx, rdx
    jne _my_memmove_loop
    mov rax, rdi
    ret

_my_memcpy_null:
    mov rax, rdi
    ret

_my_memcpy:
    xor    rax, rax
    xor rcx, rcx

_my_memcpy_loop:
    cmp   rcx, rdx
    jge   _my_memcpy_end
    inc  rcx
    mov al, [rsi]
    mov [rdi], al
    inc  rdi
    inc  rsi
    jmp  _my_memcpy_loop

_my_memcpy_end:
    sub rdi, rcx
    mov rax, rdi
    ret
