%ifdef TEST_H_
     global _my_memset ; void *memset(void *s, int c, size_t n)
     _my_memset:
%else
    global memset
    memset:
%endif
    xor rax, rax ; eax = 0
    xor rbx, rbx ; ebx = 0
    xor rcx, rcx ; rcx = 0

_my_memset_loop:
    cmp rbx, rdx
    jge _my_memset_end ; if rbx >= rdx, jump to end
    mov byte [rdi], sil ; mov byte [rdi], sil
    inc rbx ; increment rbx
    inc rdi ; increment rdi
    jmp _my_memset_loop ; jump to loop

_my_memset_end: ; jump to end
    sub rdi, rbx ; rdi = rdi - rbx
    mov rax, rdi ; rax = rdi
    ret ; return

