%ifdef TEST_H_
        global _my_strchr; int strcmp(const char *s1, const char *s2)
        _my_strchr:
   %else
       global strchr
       strchr:
   %endif
    xor eax, eax ; clear the value of eax to zero
    xor ebx, ebx ; clear the value of ebx to zero

_my_strchr_loop:
    mov al, byte [rdi] ; load the value at the memory location pointed to by `rdi` into `al`
    inc rdi ; increment the value of `rdi` by 1 to point to the next character in string 1
    cmp al, 0 ; compare the value in `al` with 0
    je _my_strchr_not_equal ; if the value in `al` is equal to 0, jump to `_my_strcmp_equal`
    cmp al, sil ; compare the value in `al` with the value in `sil`
    jne  _my_strchr_loop; if the value in `al` is equal to the value in `sil`, jump to `_my_strcmp_loop`
    dec rdi ; increment the value of `rdi` by 1 to point to the next character in string 1
    mov rax, rdi ; copy the value of `rdi` into `rax`
    ret ; return from the function

_my_strchr_not_equal:
    xor rax, rax ; clear the value of `rax` to zero
    ret ; return from the function

