%ifdef TEST_H_
    global _my_strstr
    _my_strstr: ; int strcmp(const char *s1, const char *s2)
%else
    global strstr
    strstr: ; int strcmp(const char *s1, const char *s2)
%endif
    xor eax, eax ; clear the value of eax to zero
    xor ebx, ebx ; clear the value of ebx to zero
    xor ecx, ecx ; clear the value of ecx to zero
    mov bl , byte [rsi] ; load the value at the memory location pointed to by `rsi` into `bl`
    mov al, byte [rdi] ; load the value at the memory location pointed to by `rdi` into `al`


_my_strstr_loop:
    cmp al, 0 ; compare the value in `al` with 0
    je _my_strstr_not_equal ; if the value in `al` is equal to 0, jump to `_my_strcmp_equal`
    cmp al, bl ; compare the value in `al` with bl
    je _my_strstr_comp ; if the value in `al` is not equal to the value in `bl`, jump to `_my_strcmp_not_equal`
    inc rdi ; increment the value of `rdi` by 1 to point to the next character in string 1
    mov al, byte [rdi] ; load the value at the memory location pointed to by `rdi` into `al`
    jmp _my_strstr_loop ; if the value in `al` is not equal to the value in `bl`, jump to `_my_strcmp_not_equal`
_my_strstr_comp:
    inc rsi; increment the value of `rsi` by 1 to point to the next character in string 1
    inc rdi ; increment the value of `rdi` by 1 to point to the next character in string 1
    inc rcx; increment the value of `rcx` by 1 to point to the next character in string 1
    mov al, byte [rdi] ; load the value at the memory location pointed to by `rdi` into `al`
    mov bl, byte [rsi] ; load the value at the memory location pointed to by `rsi` into `bl`
    cmp bl, 0 ; compare the value in `bl` with 0
    je _my_strstr_equal ; if the value in `bl` is equal to 0, jump to `_my_strcmp_equal`
    cmp al, 0 ; compare the value in `al` with 0
    je _my_strstr_not_equal ; if the value in `al` is equal to 0, jump to `_my_strcmp_equal`
    cmp al, bl ; compare the value in `al` with 0
    je _my_strstr_comp ; if the value in `al` is not equal to the value in `bl`, jump to `_my_strcmp_not_equal`
    sub rdi, rcx ; increment the value of `rdi` by 1 to point to the next character in string 1
    sub rsi, rcx ; increment the value of `rsi` by 1 to point to the next character in string 1
    xor rcx, rcx ; clear the value of `rcx` to zero
    jmp _my_strstr_loop ; if the value in `al` is not equal to the value in `bl`, jump to `_my_strcmp_not_equal`


_my_strstr_equal:
    sub rdi, rcx ; increment the value of `rdi` by 1 to point to the next character in string 1
    sub rsi, rcx ; increment the value of `rsi` by 1 to point to the next character in string 1
    xor rcx, rcx ; clear the value of `rcx` to zero
    mov rax, rdi
    ret ; return from the function

_my_strstr_not_equal:
    xor rax, rax ; clear the value of `rax` to zero
    ret ; return from the function

